<?php

	# 		Current Conditions Block
	# 		Namespace:		current
	#		Meteotemplate Block

	# 		v1.1 - Jan 29, 2016
	#			- added responsiveness
	# 		v2.0 - Feb 2, 2016
	#			- added UV sensor data
	# 		v2.1 - Feb 8, 2016
	#			- added UV support for Weather Link
	# 		v2.2 - Feb 19, 2016
	#			- added UV support for Meteobridge
	# 		v2.3 - Mar 1, 2016
	#			- added support for WS1001
	# 		v2.4 - Mar 5, 2016
	#			-  bug fix for Cumulus wind/gust
	# 		v3.0 - Mar 19, 2016
	#			-  added option to display wind direction as direction icon and text or degrees
	# 		v3.1 - Mar 30, 2016
	#			-  Weather Display apparent temperature bug fix
	# 		v3.2 - Apr 1, 2016
	#			-  CSS tweaks
	#		v3.3 - Apr 25, 2016
	#			-  proper unit name formatting
	#			-  bug fixes
	#		v4.0 - Jul 04, 2016
	#			- added rain rate
	#			- format wind units and pressure units
	#		v5.0 - Aug 09, 2016
	#			- possibility to add title
	#		v6.0 - Sep 30, 2016
	#			- added support for WeatherCat
	#		v6.1 - Jan 11, 2017
	#			- minor bug fixes for Cumulus data parsing
	#		v7.0 - Jan 26, 2017
	#			- added possibility to show warnings
	#			- added feature to show station as offline
	#			- CSS tweaks
	#			- converted icons to SVG objects
	# 		v8.0 - Feb 22, 2017
	# 			- added Beaufort scale
	# 		v9.0 - Mar 10, 2017
	# 			- added trends
	# 		v10.0 - Mar 13, 2017
	# 			- added support for Meteotemplate API
	# 		v10.1 - Mar 14, 2017
	# 			- minor tweaks
	# 		v11.0 - Mar 19, 2017
	# 			- added option to highlight time when data updated
	

	include("../../../config.php");
	include("../../../scripts/functions.php");
	include("../../../css/design.php");

	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}

	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];

	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);

	$filePath = urlencode($filePath);

?>
	<style>
		.conditionsIcon{
			font-size: 2em;
		}
		.currentBlockDivs{
			display: inline-block;
			width: 60px;
			padding: 5px;
			vertical-align: top;
		}
		.currentBlockWarning{
			font-size: 1.2em;
			display: none;
			padding-top:3px;
		}
		@-webkit-keyframes currentBlockWarningAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		@keyframes currentBlockWarningAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
				transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		.currentBlockWarningAnimationClass{
			-webkit-animation: currentBlockWarningAnimation 5s ease-out;
	    	-webkit-animation-iteration-count: infinite;
			animation: currentBlockWarningAnimation 5s ease-out;
	    	animation-iteration-count: infinite;
		}
		.currentBeaufort{
			width: 30%;
			margin: 0 auto;
			margin-top:2px;
			border-radius: 5px;
			font-size: 0.8em;
			font-weight:bold;
		}
		<?php 
			if(!$currentShowBftW){
		?>
				#currentWBft{
					display:none;
				}
		<?php 
			}
		?>
		<?php 
			if(!$currentShowBftG){
		?>
				#currentGBft{
					display:none;
				}
		<?php 
			}
		?>
		<?php 
			if(!$currentShowTrends){
		?>
				.currentBlockTrend{
					display:none;
				}
		<?php 
			}
		?>
	</style>
	<?php
		if($showTitle){
	?>
			<div style="text-align:center;width:100%;font-weight:bold;font-size:0.9em;font-variant:small-caps">
				<?php echo lang('current conditions','w')?>
			</div>
	<?php
		}
	?>

	<table style="width:98%;margin:0 auto;text-align:center">
		<tr>
			<td>
				<span id="currentTimestampValue" style="font-size:2em"></span>
			</td>
		</tr>
	</table>
	<div style="display:inline-block;vertical-align:top;margin:0 auto;width:98%" id="currentBlockMainDiv">
		<div class="currentBlockDivs" id="currentBlockDivT">
			<span class="mticon-temp conditionsIcon tooltip" alt='' title="<?php echo lang('temperature','c')?>"></span><br><span id="currentTValue"></span><br>°<?php echo $displayTempUnits?><div class="currentBlockTrend" id="currentBlockTrendT"></div><div class="currentBlockWarning" id="currentBlockWarningT"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivH">
			<span class="mticon-humidity conditionsIcon tooltip" alt='' title="<?php echo lang('humidity','c')?>"></span><br><span id="currentHValue"></span><br>%<div class="currentBlockTrend" id="currentBlockTrendH"></div><div class="currentBlockWarning" id="currentBlockWarningH"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivP">
			<span class="mticon-pressure conditionsIcon tooltip" alt='' title="<?php echo lang('pressure','c')?>"></span><br><span id="currentPValue"></span><br><?php echo unitFormatter($displayPressUnits)?><div class="currentBlockTrend" id="currentBlockTrendP"></div><div class="currentBlockWarning" id="currentBlockWarningP"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivW">
			<span class="mticon-wind conditionsIcon tooltip" alt='' title="<?php echo lang('wind speed','c')?>"></span><br><span id="currentWValue"></span> <?php echo unitFormatter($displayWindUnits)?><div class="currentBlockTrend" id="currentBlockTrendW"></div><span id="currentBValue"></span><div id="currentWBft" class="currentBeaufort"></div><div class="currentBlockWarning" id="currentBlockWarningW"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivG">
			<span class="mticon-gust conditionsIcon tooltip" alt='' title="<?php echo lang('wind gust','c')?>"></span><br><span id="currentGValue"></span><br><?php echo unitFormatter($displayWindUnits)?><div class="currentBlockTrend" id="currentBlockTrendG"></div><div id="currentGBft" class="currentBeaufort"></div><div class="currentBlockWarning" id="currentBlockWarningG"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivR">
			<span class="mticon-rain conditionsIcon tooltip" alt='' title="<?php echo lang('precipitation','c')?>"></span><br><span id="currentRValue" style="font-size:0.7em"></span><span style="font-size:0.7em"><?php echo $displayRainUnits?></span><br><span style="font-size:0.7em" id="currentRRValue"></span><span style="font-size:0.7em"><?php echo $displayRainUnits."/".lang('hAbbr','l')?></span><div class="currentBlockWarning" id="currentBlockWarningR"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivD">
			<span class="mticon-dewpoint conditionsIcon tooltip" alt='' title="<?php echo lang('dew point','c')?>"></span><br><span id="currentDValue"></span><br>°<?php echo $displayTempUnits?><div class="currentBlockTrend" id="currentBlockTrendD"></div><div class="currentBlockWarning" id="currentBlockWarningD"><span class="mticon-warninggeneral"></span></div>
		</div>
		<div class="currentBlockDivs" id="currentBlockDivA">
			<span class="mticon-apparent conditionsIcon tooltip" alt='' title="<?php echo lang('apparent temperature','c')?>"></span><br><span id="currentAValue"></span><br>°<?php echo $displayTempUnits?><div class="currentBlockTrend" id="currentBlockTrendA"></div><div class="currentBlockWarning" id="currentBlockWarningA"><span class="mticon-warninggeneral"></span></div>
		</div>
		<?php
			if($solarSensor){
		?>
				<div class="currentBlockDivs" id="currentBlockDivS">
					<span class="mticon-sun conditionsIcon tooltip" alt='' title="<?php echo lang('solar radiation','c')?>"></span><br><span id="currentSValue"></span><br>W/m2<div class="currentBlockWarning" id="currentBlockWarningS"><span class="mticon-warninggeneral"></span></div>
				</div>
		<?php
			}
		?>
		<?php
			if($UVsensor){
		?>
				<div class="currentBlockDivs" id="currentBlockDivUV">
					<span class="mticon-uv conditionsIcon tooltip" alt='' title="<?php echo lang('UV','c')?>"></span><br><span id="currentUVValue"></span><div class="currentBlockWarning" id="currentBlockWarningUV"><span class="mticon-warninggeneral"></span></div>
				</div>
		<?php
			}
		?>

	</div>
	<script>
		updater();
		setInterval(function(){ updater(); }, (<?php echo $updateInterval?>*1000));
		function updater(){
			//$("#currentTimestampValue").html("<span class='spinner' id='updateSpinner'>Loading…</span>");
			$.ajax({
				url : "homepage/blocks/current/updater.php?type=<?php echo $currentConditions?>&path=<?php echo $filePath?>&interval=<?php echo $currentMaxInterval?>",
				dataType : 'json',
				success : function (json) {
					if(json['offline']==0){
						$("#currentBlockMainDiv").show();
						$("#currentTValue").text(json['T']);
						$("#currentHValue").text(json['H']);
						$("#currentPValue").text(json['P']);
						$("#currentWValue").text(json['W']);
						$("#currentWBft").text(json['WBft']);
						$("#currentWBft").css("background",json['WBftBg']);
						$("#currentWBft").css("color",json['WBftColor']);
						$("#currentGValue").text(json['G']);
						$("#currentGBft").text(json['GBft']);
						$("#currentGBft").css("background",json['GBftBg']);
						$("#currentGBft").css("color",json['GBftColor']);
						$("#currentAValue").text(json['A']);
						$("#currentDValue").text(json['D']);
						$("#currentSValue").text(json['S']);
						if($("#currentSValue").text()=="null"){
							$("#currentSValue").text("");
						}
						$("#currentUVValue").text(json['UV']);
						if($("#currentUVValue").text()=="null"){
							$("#currentUVValue").text("");
						}
						$("#currentRValue").text(json['R']);
						$("#currentRRValue").text(json['RR']);
						<?php
							if($windDirectionView=="degrees"){
						?>
								$("#currentBValue").text(json['B']+"°");
						<?php
							}
							else{
						?>
								windBearing = eval(json['B']);
								if(windBearing<=11.25){ dirIcon = "n";dirText = "<?php echo lang('directionN','u')?>";}
								if(windBearing>11.25 && windBearing<=33.75){
									dirIcon = "nne";dirText = "<?php echo lang('directionNNE','u')?>";
								}
								if(windBearing>33.75 && windBearing<=56.25){
									dirIcon = "ne";dirText = "<?php echo lang('directionNE','u')?>";
								}
								if(windBearing>56.25 && windBearing<=78.75){
									dirIcon = "ene";dirText = "<?php echo lang('directionENE','u')?>";
								}
								if(windBearing>78.75 && windBearing<=101.25){
									dirIcon = "e";dirText = "<?php echo lang('directionE','u')?>";
								}
								if(windBearing>101.25 && windBearing<=123.75){
									dirIcon = "ese";dirText = "<?php echo lang('directionESE','u')?>";
								}
								if(windBearing>123.75 && windBearing<=146.25){
									dirIcon = "se";dirText = "<?php echo lang('directionSE','u')?>";
								}
								if(windBearing>146.25 && windBearing<=168.75){
									dirIcon = "sse";dirText = "<?php echo lang('directionSSE','u')?>";
								}
								if(windBearing>168.75 && windBearing<=191.25){
									dirIcon = "s";dirText = "<?php echo lang('directionS','u')?>";
								}
								if(windBearing>191.25 && windBearing<=213.75){
									dirIcon = "ssw";dirText = "<?php echo lang('directionSSW','u')?>";
								}
								if(windBearing>213.75 && windBearing<=236.25){
									dirIcon = "sw";dirText = "<?php echo lang('directionSW','u')?>";
								}
								if(windBearing>236.25 && windBearing<=258.75){
									dirIcon = "wsw";dirText = "<?php echo lang('directionWSW','u')?>";
								}
								if(windBearing>258.75 && windBearing<=281.25){
									dirIcon = "w";dirText = "<?php echo lang('directionW','u')?>";
								}
								if(windBearing>281.25 && windBearing<=303.75){
									dirIcon = "wnw";dirText = "<?php echo lang('directionWNW','u')?>";
								}
								if(windBearing>303.75 && windBearing<=326.25){
									dirIcon = "nw";dirText = "<?php echo lang('directionNW','u')?>";
								}
								if(windBearing>326.25 && windBearing<=348.75){
									dirIcon = "nnw";dirText = "<?php echo lang('directionNNW','u')?>";
								}
								if(windBearing>348.75){
									dirIcon = "n";dirText = "<?php echo lang('directionN','u')?>";
								}
								bearingString = '<img src="homepage/blocks/current/icons/<?php echo $theme?>/winddir/'+dirIcon+'.png" style="width:100%;max-width:16px">'+dirText;
								$("#currentBValue").html(bearingString);
						<?php
							}
						?>
						$("#currentTimestampValue").text(json['Timestamp']);
						<?php 
							if($currentHighlightUpdate){
						?>
								currentHighlightUpdate();
						<?php 
							}
						?>
						$(".currentBlockDivs").css("color","<?php echo $theme=="dark" ? '#fff' : '#000';?>");
						$(".currentBlockDivs").css("text-shadow","0px");
						$(".currentBlockWarning").hide();
						$(".currentBlockWarning").removeClass("currentBlockWarningAnimationClass");

						<?php
							if($showCurrentWarnings){
						?>
								if(eval(json['T'])>=<?php echo convertT($currentThresholdHighT)?>){
									$("#currentBlockWarningT").show();
									$("#currentBlockWarningT").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningT").css("color","<?php echo $currentWarningColorHighT?>");
									$("#currentBlockWarningT").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['T'])<=<?php echo convertT($currentThresholdLowT)?>){
									$("#currentBlockWarningT").show();
									$("#currentBlockWarningT").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningT").css("color","<?php echo $currentWarningColorLowT?>");
									$("#currentBlockWarningT").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['A'])>=<?php echo convertT($currentThresholdHighA)?>){
									$("#currentBlockWarningA").show();
									$("#currentBlockWarningA").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningA").css("color","<?php echo $currentWarningColorHighT?>");
									$("#currentBlockWarningA").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['A'])<=<?php echo convertT($currentThresholdLowA)?>){
									$("#currentBlockWarningA").show();
									$("#currentBlockWarningA").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningA").css("color","<?php echo $currentWarningColorLowT?>");
									$("#currentBlockWarningA").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['D'])>=<?php echo convertT($currentThresholdHighD)?>){
									$("#currentBlockWarningD").show();
									$("#currentBlockWarningD").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningD").css("color","<?php echo $currentWarningColorHighT?>");
									$("#currentBlockWarningD").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['D'])<=<?php echo convertT($currentThresholdLowD)?>){
									$("#currentBlockWarningD").show();
									$("#currentBlockWarningD").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningD").css("color","<?php echo $currentWarningColorLowT?>");
									$("#currentBlockWarningD").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['H'])>=<?php echo ($currentThresholdHighH)?>){
									$("#currentBlockWarningH").show();
									$("#currentBlockWarningH").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningH").css("color","<?php echo $currentWarningColorHighH?>");
									$("#currentBlockWarningH").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['H'])<=<?php echo ($currentThresholdLowH)?>){
									$("#currentBlockWarningH").show();
									$("#currentBlockWarningH").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningH").css("color","<?php echo $currentWarningColorLowH?>");
									$("#currentBlockWarningH").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['P'])>=<?php echo convertP($currentThresholdHighP)?>){
									$("#currentBlockWarningP").show();
									$("#currentBlockWarningP").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningP").css("color","<?php echo $currentWarningColorHighP?>");
									$("#currentBlockWarningP").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['P'])<=<?php echo convertP($currentThresholdLowP)?>){
									$("#currentBlockWarningP").show();
									$("#currentBlockWarningP").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningP").css("color","<?php echo $currentWarningColorLowP?>");
									$("#currentBlockWarningP").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['W'])>=<?php echo convertW($currentThresholdHighW)?>){
									$("#currentBlockWarningW").show();
									$("#currentBlockWarningW").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningW").css("color","<?php echo $currentWarningColorHighW?>");
									$("#currentBlockWarningW").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['G'])>=<?php echo convertW($currentThresholdHighG)?>){
									$("#currentBlockWarningG").show();
									$("#currentBlockWarningG").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningG").css("color","<?php echo $currentWarningColorHighW?>");
									$("#currentBlockWarningG").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								if(eval(json['RR'])>=<?php echo convertR($currentThresholdHighR)?>){
									$("#currentBlockWarningR").show();
									$("#currentBlockWarningR").addClass("currentBlockWarningAnimationClass");
									$("#currentBlockWarningR").css("color","<?php echo $currentWarningColorHighR?>");
									$("#currentBlockWarningR").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
								}
								<?php
									if($solarSensor){
								?>
										if(eval(json['S'])>=<?php echo ($currentThresholdHighS)?>){
											$("#currentBlockWarningS").show();
											$("#currentBlockWarningS").addClass("currentBlockWarningAnimationClass");
											$("#currentBlockWarningS").css("color","<?php echo $currentWarningColorHighS?>");
											$("#currentBlockWarningS").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
										}
								<?php
									}
								?>
								<?php
									if($UVsensor){
								?>
										if(eval(json['UV'])>=<?php echo ($currentThresholdHighUV)?>){
											$("#currentBlockWarningUV").show();
											$("#currentBlockWarningUV").addClass("currentBlockWarningAnimationClass");
											$("#currentBlockWarningUV").css("color","<?php echo $currentWarningColorHighUV?>");
											$("#currentBlockWarningUV").css("text-shadow","1px 2px 2px <?php echo $theme=="dark" ? '#fff' : '#000';?>");
										}
								<?php
									}
								?>
						<?php
							}
						?>
						<?php 
							if($currentShowTrends){
						?>
								$("#currentBlockTrendT").html(json['trendT']);
								$("#currentBlockTrendH").html(json['trendH']);
								$("#currentBlockTrendP").html(json['trendP']);
								$("#currentBlockTrendW").html(json['trendW']);
								$("#currentBlockTrendG").html(json['trendG']);
								$("#currentBlockTrendA").html(json['trendA']);
								$("#currentBlockTrendD").html(json['trendD']);
						<?php 
							}
						?>
					}
					else{
						$("#currentBlockMainDiv").hide();
						$("#currentTimestampValue").html('<span style="font-variant:small-caps"><?php echo lang('offline','c')?></span><br /><span style="font-size:0.7em"><?php echo lang("last update","c")?>: ' + json['dt']) + '</span>';
					}

				},
			});
		}
		function currentHighlightUpdate() {
			var el = document.getElementById('currentTimestampValue');
			var original = el.style.color;
			el.style.color='#<?php echo $theme=="dark" ? $color_schemes[$design2]['200'] : $color_schemes[$design2]['800']?>';
			window.setTimeout(function() { el.style.color = original; }, <?php echo ($currentHighlightInterval*1000)?>);
		}
	</script>
